#ifndef DOMAIN_H
#define DOMAIN_H

#include <set>
#include <ctime>
typedef int FaceID;
using namespace std;
class PCluster
{
public:
	float* red;
	float* green;
	float* blue;

	set<FaceID> * face_clusters;
	long * cluster_belong;
	int size;

public:
	PCluster(int n)
	{
		size = n;
		red = new float[n];
		green = new float[n];
		blue = new float[n];
		face_clusters = new set<FaceID>[n];
		cluster_belong = new long[n];

		for (int i=0; i< n; i++)
		{
			red[i] = (rand()%21)/21.0;
			green[i] = (rand()%21)/21.0;
			blue[i] = (rand()%21)/21.0;
			face_clusters[i].clear();
		}

		//at first, each domain only contain and belong to itself
		for (int i=0; i< n; i++)
		{
			face_clusters[i].insert(i);
			cluster_belong[i] = i;
		}
		
	}

	~PCluster()
	{
		delete [] red;
		delete [] green;
		delete [] blue;
		delete [] face_clusters;
		delete [] cluster_belong;
	}

	void mergeDomain(int v1, int v2)
	{		
		//update containing and belonging information
		for (set<int>::iterator it = face_clusters[v2].begin(); it !=face_clusters[v2].end(); it++)
		{
			face_clusters[v1].insert(*it);
			cluster_belong[*it] = v1;
		}
		face_clusters[v2].clear();	
	}
};

#endif